using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace martianface
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        BasicEffect be;
        Martian face;
        VertexDeclaration vd;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here
            be = new BasicEffect(graphics.GraphicsDevice, null);

            Matrix view = Matrix.CreateLookAt(new Vector3(0, 0, 0), new Vector3(0, 0, 1), new Vector3(0, 1, 0));
            Matrix per = Matrix.CreatePerspectiveFieldOfView(1.5f, 1, 0.1f, 100);
            
            be.View = view;
            be.Projection = per;
            be.World = Matrix.Identity;
            
            be.LightingEnabled = false;
            be.VertexColorEnabled = true;  
            
            be.CommitChanges();

            face = new Martian();
            base.Initialize();
            graphics.GraphicsDevice.RenderState.CullMode = CullMode.None; // no backface culling
            vd = new VertexDeclaration(graphics.GraphicsDevice, VertexPositionColor.VertexElements);
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            // TODO: use this.Content to load your game content here
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            // TODO: Add your update logic here
            be.World = Matrix.CreateRotationY((float)gameTime.TotalRealTime.TotalMilliseconds / 1000.0f);
//            be.World = Matrix.Multiply(be.World, Matrix.CreateTranslation(0.0f, 0.0f, 4.1f));
            be.CommitChanges();
            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            graphics.GraphicsDevice.VertexDeclaration = vd;
            GraphicsDevice.Clear(Color.CornflowerBlue);

            // TODO: Add your drawing code here

            be.Begin();
            foreach (EffectPass pass in be.CurrentTechnique.Passes)
            {
                pass.Begin();
                face.Draw(graphics.GraphicsDevice);
                pass.End();
            }
            be.End();

            base.Draw(gameTime);
        }
    }
}
